package me.eater.hefbrug.dsl.context

import me.eater.hefbrug.dsl.Location
import me.eater.hefbrug.dsl.annotation.HefbrugDSL
import me.eater.hefbrug.executor.Executor

@HefbrugDSL
@Suppress("UNUSED")
open class SourceContext(private val root: RootContext, var location: Location, private val executor: Executor) :
    RootContextSkeleton by root,
    SelectionDefinitionContext<suspend TargetedContext.() -> Unit> by root,
    SourceContextSkeleton {
    fun include(vararg file: String) {
        for (f in file) {
            executor.run(location.resolve(f))
        }
    }
}