package me.eater.hefbrug.dsl.scope

import me.eater.hefbrug.definition.DefinitionFactory
import me.eater.hefbrug.definition.DefinitionKey
import me.eater.hefbrug.definition.DefinitionSkeleton
import me.eater.hefbrug.dsl.context.DefinitionContextSkeleton
import me.eater.hefbrug.state.AbstractState

class RootScope : ScopeInterface {
    private val definitionsMut =
        mutableMapOf<DefinitionKey, DefinitionSkeleton<*, *>>()

    val definitions by lazy { definitionsMut }

    @Suppress("UNCHECKED_CAST")
    override fun <S : AbstractState, C : DefinitionContextSkeleton<S>, D : DefinitionSkeleton<S, C>> getDefinition(
        id: String,
        factory: DefinitionFactory<S, C, D>
    ): D =
        definitionsMut.getOrPut(factory.key(id)) {
            factory.build(id)
        } as D
}